function createHandler(...)
	addEventHandler("onClientRender", root, ...)
end

function removeHandler(...)
	removeEventHandler("onClientRender", root, ...)
end

function dxDrawRectangleBorder(x, y, w, h, color, fgh, class)
	dxDrawRectangle( x, y, w, h, color, fgh)
	if class == "1" then
 		dxDrawRectangle(x, y - 1, w, 1, color, fgh)
		dxDrawRectangle(x, y + h, w, 1, color, fgh)
		dxDrawRectangle(x - 1, y, 1, h, color, fgh)
		dxDrawRectangle(x + w, y, 1, h, color, fgh)
	elseif class == "2" then
 		dxDrawRectangle(x, y - 1, w, 1, color, fgh)
 		dxDrawRectangle(x - 1, y - 1, w, 1, color, fgh)
		dxDrawRectangle(x, y + h, w, 1, color, fgh)
		dxDrawRectangle(x - 1, y + h, w, 1, color, fgh)
		dxDrawRectangle(x - 1, y, 1, h, color, fgh)
		dxDrawRectangle(x - 2, y, 1, h, color, fgh)
		dxDrawRectangle(x + w, y, 1, h, color, fgh)
	elseif class == "3" then
		dxDrawRectangle(x + 2, y - 1, w - 4, 1, color, fgh)
		dxDrawRectangle(x + 2, y + h, w - 4, 1, color, fgh)
		dxDrawRectangle(x - 1, y + 2, 1, h - 4, color, fgh)
		dxDrawRectangle(x + w, y + 2, 1, h - 4, color, fgh)
	elseif class == "4" then
		dxDrawRectangle(x + 1, y - 1, w - 2, 1, color, fgh)
		dxDrawRectangle(x + 1, y + h, w - 2, 1, color, fgh)
		dxDrawRectangle(x - 1, y + 1, 1, h - 2, color, fgh)
		dxDrawRectangle(x + w, y + 1, 1, h - 2, color, fgh)
	end
end

function dxCreateBorder(x,y,w,h,color)
	dxDrawRectangle(x,y,w+1,1,color)
	dxDrawRectangle(x,y+1,1,h,color)
	dxDrawRectangle(x+1,y+h,w,1,color)
	dxDrawRectangle(x+w,y+1,1,h,color)
end

function getCursorFuck()
	cX, cY = getCursorPosition()
	cX, cY = cX*ScreenW, cY*ScreenH
	return cX, cY
end

function isEventHandlerAdded( sEventName, pElementAttachedTo, func )
	if type( sEventName ) == 'string' and isElement( pElementAttachedTo ) and type( func ) == 'function' then
		local aAttachedFunctions = getEventHandlers( sEventName, pElementAttachedTo )
		if type( aAttachedFunctions ) == 'table' and #aAttachedFunctions > 0 then
			for i, v in ipairs( aAttachedFunctions ) do
				if v == func then
					return true
				end
			end
		end
	end
	return false
end

function isCursorClient(dX, dY, dSZ, dM, eX, eY)
	if(eX >= dX and eX <= dX+dSZ and eY >= dY and eY <= dY+dM) then
		return true
	else
		return false
	end
end

function convertTemp( seconds )
	if seconds then
		local results = {}
		local sec = ( seconds %60 )
		local min = math.floor ( ( seconds % 3600 ) /60 )
		local hou = math.floor ( ( seconds % 86400 ) /3600 )
		local day = math.floor ( seconds /86400 )
		
		if day > 0 then table.insert( results, day .. ( day == 1 and " dia" or " dias" ) ) end
		if hou > 0 then table.insert( results, hou .. ( hou == 1 and " hora" or " horas" ) ) end
		if min > 0 then table.insert( results, min .. ( min == 1 and " minuto" or " minutos" ) ) end
		if sec > 0 then table.insert( results, sec .. ( sec == 1 and " segundo" or " segundos" ) ) end
		
		return string.reverse ( table.concat ( results, ", " ):reverse():gsub(" ,", " e ", 1 ) )
	end
	return ""
end

function formatMoney(amount)
	local formatted = tonumber(amount)
	if formatted then
		while true do  
			formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1 %2')
		if (k==0) then
			break
		end
	end
		return formatted
	else
		return amount
	end
end

function convertNumber(number)  
	local formatted = number  
	while true do      
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", "%1,%2")    
		if ( k==0 ) then      
			break   
		end  
	end  
	return formatted
end

function getPointFromDistanceRotation( x, y, dist, angle )
	local a = math.rad( 90 - angle )
	local dx = math.cos( a ) * dist
	local dy = math.sin( a ) * dist
	return x+dx, y+dy;
end

function findRotation( x, y, bx, by )
	local math = -math.deg( math.atan2( bx - x , by - y ) )
	if math < 0 then 
		math = math + 360 
	end
	return math;
end

function createCursorOnElement(posX, posY, width, height)
	if isCursorShowing() then
		local mouseX, mouseY = getCursorPosition()
		local clientW, clientH = guiGetScreenSize()
		local mouseX, mouseY = mouseX * clientW, mouseY * clientH
		if ( mouseX > posX and mouseX < ( posX + width ) and mouseY > posY and mouseY < ( posY + height ) ) then
			return true
		end
	end
	return false
end